unit rsv501sprav;
{

 VL:
Copyright (C) 2017  . .

 ,        .
  5.01,     10.10.2016  -7-11/551@

}

interface

uses Classes;

type

 //     
 TDataRec = record
             Code  : ANSIString;          // 
             Value : ANSIString;          // 
            end;

 //    
 TSprav = class
           Data : array of TDataRec;
{

   .

DType:

 0 -  
 1 -  "  "
 2 - 
 3 -        
 4 -        
}
           procedure Init (DType : integer);
           function getValue (Code : ANSIString) : ANSIString;
          end;

//    ""        
function getCompatibleZLCatCodesListByCatCode (CatCode : ANSIString) : TStringList;

//    ""        
function getCompatibleZLCatCodesListByTarif (Tarif : ANSIString) : TStringList;

//    ""      
function getCompatibleTarifListByTarif (Tarif : ANSIString) : TStringList;

//    ""       
function getCompatibleTarifListByCatCode (CatCode : ANSIString) : TStringList;

//      3   
function getLast3MonthsCodes (Period : ANSIString) : TStringList;

{
//      ,       :

0 -  
1 -  

}
function getStavka (Year, CatCode : ANSIString; Vid : integer) : Currency;

implementation

function getCompatibleZLCatCodesListByTarif (Tarif : ANSIString) : TStringList;
begin
 if (Tarif = '01') or (Tarif = '02') or (Tarif = '03') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '04') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '05') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '06') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '13') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '09') or (Tarif = '10') or (Tarif = '11') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '07') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '08') or (Tarif = '12') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '14') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '15') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '16') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '17') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else if (Tarif = '18') then Result := getCompatibleZLCatCodesListByCatCode ('')
 else begin
       Result := TStringList.Create;
       Result.Clear;
      end;
end;

function getCompatibleZLCatCodesListByCatCode (CatCode : ANSIString) : TStringList;
begin
 Result := TStringList.Create;
 Result.Clear;
 if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end
 else if (CatCode = '') or (CatCode = '') or (CatCode = '')
  then begin
        Result.Add ('');
        Result.Add ('');
        Result.Add ('');
       end;
end;

function getCompatibleTarifListByTarif (Tarif : ANSIString) : TStringList;
begin
 Result := TStringList.Create;
 Result.Clear;
 if (Tarif = '01') or (Tarif = '02') or (Tarif = '03')
  then begin
        Result.Add ('01');
        Result.Add ('02');
        Result.Add ('03');
       end
 else if (Tarif = '08') or (Tarif = '12')
  then begin
        Result.Add ('08');
        Result.Add ('12');
       end
 else if (Tarif = '09') or (Tarif = '10') or (Tarif = '11')
  then begin
        Result.Add ('09');
        Result.Add ('10');
        Result.Add ('11');
       end
 else if (Tarif = '04') or (Tarif = '05') or (Tarif = '06') or (Tarif = '07') or (Tarif = '13') or (Tarif = '14') or (Tarif = '15') or (Tarif = '16') or (Tarif = '17') or (Tarif = '18')
  then begin
        Result.Add (Tarif);
       end;
end;


function getCompatibleTarifListByCatCode (CatCode : ANSIString) : TStringList;
begin
 if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('01')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('04')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('05')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('06')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('13')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('09')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('07')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('08')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('14')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('15')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('16')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('17')
 else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := getCompatibleTarifListByTarif ('18')
 else begin
       Result := TStringList.Create;
       Result.Clear;
      end;
end;

procedure TSprav.Init (DType : integer);
begin
 SetLength (Data,0);
 if DType = 0
  then begin
        SetLength (Data,12);
        with Data [0]
         do begin
             Code := '21';
             Value := '1 ';
            end;
        with Data [1]
         do begin
             Code := '31';
             Value := '';
            end;
        with Data [2]
         do begin
             Code := '33';
             Value := ' ';
            end;
        with Data [3]
         do begin
             Code := '34';
             Value := '';
            end;
        with Data [4]
         do begin
             Code := '51';
             Value := '1    () ';
            end;
        with Data [5]
         do begin
             Code := '52';
             Value := '   () ';
            end;
        with Data [6]
         do begin
             Code := '53';
             Value := '9    () ';
            end;
        with Data [7]
         do begin
             Code := '90';
             Value := '   () ';
            end;
        with Data [8]
         do begin
             Code := '83';
             Value := '1          (  () )';
            end;
        with Data [9]
         do begin
             Code := '84';
             Value := '         (  () )';
            end;
        with Data [10]
         do begin
             Code := '85';
             Value := '9          (  () )';
            end;
        with Data [11]
         do begin
             Code := '86';
             Value := '         (  () )';
            end;
       end
 else if DType = 1
  then begin
        SetLength (Data,11);
        with Data [0]
         do begin
             Code := '112';
             Value := '    ,    ';
            end;
        with Data [1]
         do begin
             Code := '120';
             Value := '    ';
            end;
        with Data [2]
         do begin
             Code := '121';
             Value := '   ,   ';
            end;
        with Data [3]
         do begin
             Code := '122';
             Value := '   ,   ';
            end;
        with Data [4]
         do begin
             Code := '124';
             Value := '    ()  () ';
            end;
        with Data [5]
         do begin
             Code := '214';
             Value := '    ';
            end;
        with Data [6]
         do begin
             Code := '217';
             Value := '     ';
            end;
        with Data [7]
         do begin
             Code := '222';
             Value := '         ';
            end;
        with Data [8]
         do begin
             Code := '335';
             Value := '         ';
            end;
        with Data [9]
         do begin
             Code := '350';
             Value := '       ';
            end;
        with Data [10]
         do begin
             Code := '240';
             Value := '     - ()  () ';
            end;
       end
 else if DType = 2
  then begin
        SetLength (Data,12);
        with Data [0]
         do begin
             Code := '01';
             Value := '';
            end;
        with Data [1]
         do begin
             Code := '02';
             Value := '';
            end;
        with Data [2]
         do begin
             Code := '03';
             Value := '';
            end;
        with Data [3]
         do begin
             Code := '04';
             Value := '';
            end;
        with Data [4]
         do begin
             Code := '05';
             Value := '';
            end;
        with Data [5]
         do begin
             Code := '06';
             Value := '';
            end;
        with Data [6]
         do begin
             Code := '07';
             Value := '';
            end;
        with Data [7]
         do begin
             Code := '08';
             Value := '';
            end;
        with Data [8]
         do begin
             Code := '09';
             Value := '';
            end;
        with Data [9]
         do begin
             Code := '10';
             Value := '';
            end;
        with Data [10]
         do begin
             Code := '11';
             Value := '';
            end;
        with Data [11]
         do begin
             Code := '12';
             Value := '';
            end;
       end
 else if DType = 3
  then begin
        SetLength (Data, 3);
        with Data [0]
         do begin
             Code := '2017';
             Value := '876000';
            end;
        with Data [1]
         do begin
             Code := '2018';
             Value := '1021000';
            end;
        with Data [2]
         do begin
             Code := '2019';
             Value := '1150000';
            end;
       end
 else if DType = 4
  then begin
        SetLength (Data, 3);
        with Data [0]
         do begin
             Code := '2017';
             Value := '755000';
            end;
        with Data [1]
         do begin
             Code := '2018';
             Value := '815000';
            end;
        with Data [2]
         do begin
             Code := '2019';
             Value := '865000';
            end;
       end;
end;

function TSprav.getValue (Code : ANSIString) : ANSIString;
var
 i : integer;
begin
 Result := '';
 if Length (Data) > 0 then for i := 0 to Length (Data) - 1 do if Data [i].Code = Code
  then begin
        Result := Data [i].Value;
        Break;
       end;
end;

function getLast3MonthsCodes (Period : ANSIString) : TStringList;
begin
 Result := TStringList.Create;
 Result.Clear;
 if (Period = '21') or (Period = '51')
  then begin
        Result.Add ('01');
        Result.Add ('02');
        Result.Add ('03');
       end
 else if (Period = '31') or (Period = '52')
  then begin
        Result.Add ('04');
        Result.Add ('05');
        Result.Add ('06');
       end
 else if (Period = '33') or (Period = '53')
  then begin
        Result.Add ('07');
        Result.Add ('08');
        Result.Add ('09');
       end
 else if (Period = '34') or (Period = '90')
  then begin
        Result.Add ('10');
        Result.Add ('11');
        Result.Add ('12');
       end;
end;

function getStavka (Year, CatCode : ANSIString; Vid : integer) : Currency;
begin
    if (Year = '2017')
     then begin
           // 2017 
           if Vid = 0
            then begin
                  // 0 -  
                  if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 5.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 4
                  else if (CatCode = '')  or (CatCode = '') or (CatCode = '') then Result := 4
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 4
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1;
                 end
           else if Vid = 1
            then begin
                  // 1 -  
                  if (CatCode = '') or  (CatCode = '') then Result := 2.9
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or  (CatCode = '') then Result := 2
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or  (CatCode = '') then Result := 2
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or  (CatCode = '') then Result := 2
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5;
                 end
           else Result := 0;
          end
    else if (Year = '2018')
     then begin
           // 2018 
           if Vid = 0
            then begin
                  // 0 -  
                  if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 5.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 5.1
                  else if (CatCode = '')  or (CatCode = '') or (CatCode = '') then Result := 5.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 4
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 4
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1;
                 end
           else if Vid = 1
            then begin
                  // 1 -  
                  if (CatCode = '') or  (CatCode = '') then Result := 2.9
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or  (CatCode = '') then Result := 2.9
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or  (CatCode = '') then Result := 2.9
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or  (CatCode = '') then Result := 2
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') then Result := 2
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5;
                 end
           else Result := 0;
          end
    else if (Year = '2019')
     then begin
           // 2019 
           if Vid = 0
            then begin
                  // 0 -  
                  if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 5.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 5.1
                  else if (CatCode = '')  or (CatCode = '') or (CatCode = '') then Result := 5.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 4
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 4
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0.1;
                 end
           else if Vid = 1
            then begin
                  // 1 -  
                  if (CatCode = '') or  (CatCode = '') then Result := 2.9
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or  (CatCode = '') then Result := 2.9
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or  (CatCode = '') then Result := 2.9
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or  (CatCode = '') then Result := 2
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') then Result := 2
                  else if (CatCode = '') then Result := 1.8
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 0
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5
                  else if (CatCode = '') or (CatCode = '') or (CatCode = '') then Result := 1.5;
                 end
           else Result := 0;
          end
     else Result := 0;
end;

end.